@ECHO OFF
CLS
SET VER=18
IF NOT EXIST PMAPED\SYSTEM\B%VER%.CHK GOTO INIT_WARNING
:INIT
ECHO.>PMAPED\SYSTEM\B%VER%.CHK
IF NOT EXIST MAPEDIT.EXE COPY PMAPED\EXE.ORG MAPEDIT.EXE>nul
IF NOT EXIST MAPEDIT.INI COPY PMAPED\INI.ORG MAPEDIT.INI>nul
ECHO.>PMAPED\PATCH.LOG
SET CURSCR=a
SET CURPTCH=-1
SET SCRMODEA=PMAPED\SCRN S>nul
SET SCRMODEB=PMAPED\SCRN D>nul
SET CRKFILE=PMAPED\SYSTEM\CRACK.CRK
TYPE PMAPED\SYSTEM\HEAD.CRK>%CRKFILE%
:mscreen
GOTO %CURSCR%
:: --------------------------------------------------------------------------------
:a
%SCRMODEA%
ECHO.
ECHO    [1;33mPATCHED MAPEDIT [1;32mBETA%VER%                  [1;31mPRESS [1;32m[R][1;31m TO RESET OR [1;32m[X][1;31m TO EXIT[0m
ECHO    
ECHO    [1;32m[1] [1;37mAPPLY BASIC MAPEDIT PATCH. [1;33m*[0m
ECHO        - Fully compatible with vanilla map editor and vanilla Blood.
ECHO          Press [0;32m[I][0m key to see full changelog.
ECHO.
ECHO    [1;32m[2] [1;37mUSE MAPEDIT.INI TO STORE SETTINGS.[0m [1;33m*[0m
ECHO        - Allows to store video and sound settings in MAPEDIT.INI. Can be
ECHO          useful for DOS user that tired to switch video resolution.
ECHO.
ECHO    [1;32m[3] [1;37mADD NEW TYPE NAMES IN 2D MODE SPRITE EDIT LIST.[0m
ECHO        - Allows to select which exactly names of types should be added:
ECHO          Vanilla Blood compatible hidden types, new types for modern
ECHO          standard mappers or maybe both? Press [0;32m[T][0m key for more info.
ECHO.
ECHO    [1;32m[4] [1;37mUNLOCK HIDDEN COMMANDS BETWEEN 11 AND 64. [1;33m*[0m
ECHO        - Not tested carefully, so you have to experiment :)
ECHO.
ECHO    [1;32m[5] [1;37mENABLE SAVING MAP FILE WITH VERSION 7.1. [1;33m*[0m
ECHO        - Intended for mappers wich aim for using modern features of 
ECHO          source ports such as NBLOOD. It automatically gives access 
ECHO          to all the features, so it's not required to enable it manually 
ECHO          by creating the control x-sprite in maps. This version is still 
ECHO          can be loaded in vanilla editor and in the game.
ECHO.
ECHO    [1;32m[6] [1;37mAUTO-ADJUST SPRITES FUNCTION OPTIONS... [0m
ECHO        - If only you still feel there is not enough freedom.
ECHO.
CHOICE /C:123456itrsx /N " "
CLS
IF ERRORLEVEL 10 GOTO exit
IF ERRORLEVEL 9 GOTO defaults
IF ERRORLEVEL 8 GOTO typesinfo
IF ERRORLEVEL 7 GOTO basicinfo
IF ERRORLEVEL 6 GOTO toggleScr
IF ERRORLEVEL 5 GOTO mapv0701
IF ERRORLEVEL 4 GOTO cmd
IF ERRORLEVEL 3 GOTO type_choice
IF ERRORLEVEL 2 GOTO ubind
IF ERRORLEVEL 1 GOTO basic
GOTO mscreen
:: --------------------------------------------------------------------------------
:b
%SCRMODEB%
ECHO.
ECHO    [0;36mSELECT AN ITEM TO PATCH          [1;31mPRESS [1;32m[R][1;31m TO RESET OR [1;32m[Q][1;31m TO RETURN BACK[0m
ECHO    
ECHO    [1;32m[1] [1;37mDISABLE SPRITE PALETTE AUTO-ADJUSTING.[0m
ECHO        - Allows to paint monsters and other things that cannot be painted.
ECHO.
ECHO    [1;32m[2] [1;37mDISABLE SPRITE SIZE AUTO-ADJUSTING.[0m
ECHO        - Allows to resize monsters and other things that cannot be resized.
ECHO.
ECHO    [1;35m[0] [1;37mDISABLE AUTO-ADJUST FUNCTION COMPLETELLY.[0m
ECHO        - Recommended only if sure you can control everything manually.
CHOICE /C:120qr /N " "
CLS
IF ERRORLEVEL 5 GOTO defaults
IF ERRORLEVEL 4 GOTO toggleScr
IF ERRORLEVEL 3 GOTO full
IF ERRORLEVEL 2 GOTO size
IF ERRORLEVEL 1 GOTO pal
GOTO mscreen
:: --------------------------------------------------------------------------------

:toggleScr
IF %CURSCR% == a GOTO setBscr
IF %CURSCR% == b GOTO setAscr
GOTO exit

:setAscr
SET CURSCR=a
GOTO mscreen

:setBscr
SET CURSCR=b
GOTO mscreen

:basicinfo
CLS
%SCRMODEB%
PMAPED\QSCROLL PMAPED\CHLOG.TXT
GOTO mscreen

:typesinfo
CLS
%SCRMODEB%
PMAPED\QSCROLL PMAPED\TYPCHLG.TXT
GOTO mscreen

:: --------------------------------------------------------------------------------
:basic
SET CURPTCH=0
TYPE PMAPED\PREBASE.CRK>>%CRKFILE%
TYPE PMAPED\NOXSPR.CRK>>%CRKFILE%
TYPE PMAPED\NOCRC.CRK>>%CRKFILE%
TYPE PMAPED\XDECOR.CRK>>%CRKFILE%
TYPE PMAPED\PBASIC1.CRK>>%CRKFILE%
TYPE PMAPED\PBASIC3.CRK>>%CRKFILE%
TYPE PMAPED\PBASIC4.CRK>>%CRKFILE%
TYPE PMAPED\PBASIC5.CRK>>%CRKFILE%
TYPE PMAPED\PBASIC6.CRK>>%CRKFILE%
TYPE PMAPED\MAPDSTYP.CRK>>%CRKFILE%
TYPE PMAPED\PALDUDE.CRK>>%CRKFILE%
TYPE PMAPED\PALKEY.CRK>>%CRKFILE%
TYPE PMAPED\PALMISC.CRK>>%CRKFILE%
TYPE PMAPED\RSZDUDE.CRK>>%CRKFILE%
TYPE PMAPED\HITSCAN.CRK>>%CRKFILE%
TYPE PMAPED\ASAVESTR.CRK>>%CRKFILE%
TYPE PMAPED\NEWBOARD.CRK>>%CRKFILE%
TYPE PMAPED\STRWALL1.CRK>>%CRKFILE%
TYPE PMAPED\SHORTSTR.CRK>>%CRKFILE%
TYPE PMAPED\TILESCR.CRK>>%CRKFILE%
TYPE PMAPED\PRADIUS.CRK>>%CRKFILE%
TYPE PMAPED\EYEHEIT.CRK>>%CRKFILE%
TYPE PMAPED\SYSMSG.CRK>>%CRKFILE%
TYPE PMAPED\BEEPDEC.CRK>>%CRKFILE%
TYPE PMAPED\FRMRATE.CRK>>%CRKFILE%
GOTO basic_board_size

:basic_board_size
%SCRMODEB%
ECHO.
ECHO  [1;37mDO YOU WANT TO INCREASE MAPEDIT'S BOARD SIZE? [1;32m[Y/N][0m
ECHO  --------------------------------------------------------------------
ECHO.
ECHO  This will increase board size from 131 072 to 196 608.
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 GOTO basic_diff_sky
IF ERRORLEVEL 1 GOTO basic_board_size_ok
:basic_board_size_ok
TYPE PMAPED\PBASIC2.CRK>>%CRKFILE%
GOTO basic_diff_sky

:basic_diff_sky
ECHO.
ECHO  [1;37mDO YOU WANT TO BE ABLE SET DIFFERENT SKY FOR EACH SECTOR? [1;32m[Y/N][0m
ECHO  --------------------------------------------------------------------
ECHO.
ECHO  If you need set same picture for all parallaxed sectors, you still 
ECHO  can use Ctrl+Enter key combination.
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 GOTO basic_remap_keys
IF ERRORLEVEL 1 GOTO basic_diff_sky_ok
:basic_diff_sky_ok
TYPE PMAPED\DIFFSKY.CRK>>%CRKFILE%
GOTO basic_remap_keys

:basic_remap_keys
ECHO.
ECHO  [1;37mDO YOU WANT TO REMAP ALT+ENTER KEY SEQUENCE? [1;32m[Y/N][0m
ECHO  --------------------------------------------------------------------
ECHO.
ECHO  It will remap Alt+Enter key sequence which used to paste xobject 
ECHO  properties (or clear it) to Pad5+Enter. This may solve dosbox fullscreen 
ECHO  problem for users who don't know how to remap it.
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 GOTO basic_320p
IF ERRORLEVEL 1 GOTO basic_remap_keys_ok
:basic_remap_keys_ok
TYPE PMAPED\KEYPAD5.CRK>>%CRKFILE%
GOTO basic_320p

:basic_320p
ECHO.
ECHO  [1;37mDO YOU WANT TO APPLY 320P RESOLUTION PATCH? [1;32m[Y/N][0m
ECHO  --------------------------------------------------------------------
ECHO.
ECHO  It will fix texture panning speed and make mouse crosshair smaller.
ECHO  This patch fits 320p mostly, however users with higher resolutions
ECHO  could try it too.
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 GOTO basic_items
IF ERRORLEVEL 1 GOTO basic_320p_ok
:basic_320p_ok
TYPE PMAPED\320PANS.CRK>>%CRKFILE%
TYPE PMAPED\320SML1.CRK>>%CRKFILE%
GOTO basic_items

:basic_items
CLS
ECHO.
ECHO  [1;37mDO YOU WANT ACTIVE UNUSED ITEMS TO BE ADDED IN ITEMS MENU? [1;32m[Y/N][0m
ECHO  --------------------------------------------------------------------
ECHO.
ECHO  This will add items such as Gas Mask, Red Potion and Feather Fall to 
ECHO  items menu in 3D mode (Alt+S) by replacement inactive shrooms. It will 
ECHO  also replace Wooden Chest to Medicine Pouch.
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 GOTO PATCHIT
IF ERRORLEVEL 1 GOTO basic_items_ok
GOTO mscreen
:basic_items_ok
TYPE PMAPED\ITEMGM.CRK>>%CRKFILE%
TYPE PMAPED\ITEMFF.CRK>>%CRKFILE%
TYPE PMAPED\ITEMMP.CRK>>%CRKFILE%
TYPE PMAPED\ITEMRP.CRK>>%CRKFILE%
CLS
GOTO PATCHIT
:: --------------------------------------------------------------------------------


:type_choice
CLS
%SCRMODEB%
SET tcontinue=
ECHO.
ECHO    [0;36mSELECT WHICH TYPES SHOULD BE ADDED             [1;31mPRESS [1;32m[Q][1;31m TO RETURN BACK[0m
ECHO    
ECHO    [1;32m[1] [1;37mADD JUST MODERN PORTS COMPATIBLE NAMES IN LIST[0m
ECHO        - It will add 14 new types that opens wide range of new features
ECHO          for mappers such as enemy customization and new triggers. All of it 
ECHO          supported by NBLOOD 1.10 and BloodGDX 0.800 and later versions. The
ECHO          detailed documentation for each type and any new updates related
ECHO          to new triggers can be found on: [1;33mhttp://cruo.bloodgame.ru/xxsystem[0m
ECHO.
ECHO    [1;32m[2] [1;37mADD JUST VANILLA COMPATIBLE NAMES IN LIST[0m
ECHO        - It will add 8 hidden types which used by game and cannot be put
ECHO          in map by designer normally. Still, you can use them with this
ECHO          patch. Since these types used by vanilla game, they also compatible
ECHO          with any other existing Blood port. The detailed documentation for 
ECHO          each type can be found on: [1;33mhttp://cruo.bloodgame.ru/pmapedit/types[0m
ECHO.
ECHO.
ECHO.
ECHO    [1;32m[3] [1;37mADD BOTH VANILLA AND MODERN NAMES[0m
ECHO        - Allows to have all names in the same time to give you total freedom
ECHO          in selection of which one should be used.
ECHO.
CHOICE /C:123q /N " "
IF ERRORLEVEL 4 GOTO mscreen
IF ERRORLEVEL 3 GOTO types_both
IF ERRORLEVEL 2 GOTO types_vanilla_confirm
IF ERRORLEVEL 1 GOTO types_modern_confirm
CLS

:types_both
SET tcontinue=1
:types_vanilla_confirm
%SCRMODEB%
ECHO  [1;31m
ECHO  IMPORTANT! 
ECHO  THIS PATCH IS NOT COMPATIBLE WITH VANILLA MAPEDIT!
ECHO.
ECHO  ONCE MAP IS EDITED IN VANILLA MAPEDIT, NEW TYPES
ECHO  WILL RESET BACK TO ZERO. CONTINUE? [1;32m[Y/N][0m
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 GOTO type_choice
IF ERRORLEVEL 1 GOTO types_vanilla_confirmed
GOTO types_vanilla_confirm
:types_vanilla_confirmed
SET CURPTCH=1
TYPE PMAPED\PREBASE.CRK>>%CRKFILE%
TYPE PMAPED\TYPCMPLT.CRK>>%CRKFILE%
CLS
IF NOT .%tcontinue% == .1 GOTO PATCHIT
IF .%tcontinue% == .1 GOTO types_modern_confirmed
GOTO types_modern_confirm

:types_modern_confirm
%SCRMODEB%
ECHO  [1;31m
ECHO  IMPORTANT! 
ECHO  THIS PATCH IS NOT COMPATIBLE WITH VANILLA MAPEDIT
ECHO  AND NEW TYPES WILL NOT WORK IN DOS VERSION OF BLOOD!
ECHO.
ECHO  ONCE MAP IS EDITED IN VANILLA MAPEDIT, NEW TYPES
ECHO  WILL RESET BACK TO ZERO. CONTINUE? [1;32m[Y/N][0m
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 GOTO type_choice
IF ERRORLEVEL 1 GOTO types_modern_confirmed
:types_modern_confirmed
SET CURPTCH=1
TYPE PMAPED\PREBASE.CRK>>%CRKFILE%
TYPE PMAPED\TYPMDRN1.CRK>>%CRKFILE%
TYPE PMAPED\TYPMDRN2.CRK>>%CRKFILE%
TYPE PMAPED\TYPMDRN3.CRK>>%CRKFILE%
TYPE PMAPED\TYPMDRN4.CRK>>%CRKFILE%
TYPE PMAPED\TYPMDRN5.CRK>>%CRKFILE%
TYPE PMAPED\TYPMDRN6.CRK>>%CRKFILE%
TYPE PMAPED\TYPMDRN7.CRK>>%CRKFILE%
TYPE PMAPED\INCMAX.CRK>>%CRKFILE%
TYPE PMAPED\NEGATIV.CRK>>%CRKFILE%
GOTO PATCHIT

:pal
%SCRMODEB%
ECHO  [1;31m
ECHO  IMPORTANT! 
ECHO  THIS PATCH IS NOT COMPATIBLE WITH VANILLA MAPEDIT!
ECHO.
ECHO  ONCE MAP IS EDITED IN VANILLA MAPEDIT, PALETTES
ECHO  WILL RESET TO THEIR PREDEFINED VALUES. CONTINUE? [1;32m[Y/N][0m
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 GOTO mscreen
IF ERRORLEVEL 1 GOTO pal_confirmed
:pal_confirmed
SET CURPTCH=2
TYPE PMAPED\MAPDSPAL.CRK>>%CRKFILE%
GOTO PATCHIT

:size
%SCRMODEB%
ECHO  [1;31m
ECHO  IMPORTANT! 
ECHO  THIS PATCH IS NOT COMPATIBLE WITH VANILLA MAPEDIT!
ECHO.
ECHO  ONCE MAP IS EDITED IN VANILLA MAPEDIT, SIZE
ECHO  WILL RESET TO IT'S PREDEFINED VALUES. CONTINUE? [1;32m[Y/N][0m
CHOICE /C:yn /N " "
CLS
IF ERRORLEVEL 2 GOTO mscreen
IF ERRORLEVEL 1 GOTO size_confirmed
:size_confirmed
SET CURPTCH=3
TYPE PMAPED\MAPDSIZE.CRK>>%CRKFILE%
GOTO PATCHIT

:cmd
SET CURPTCH=4
TYPE PMAPED\MAPDCMD.CRK>>%CRKFILE%
GOTO PATCHIT

:full
SET CURPTCH=5
TYPE PMAPED\MAPDAAD.CRK>>%CRKFILE%
GOTO PATCHIT

:mapv0701
SET CURPTCH=6
TYPE PMAPED\MAPV0701.CRK>>%CRKFILE%
GOTO PATCHIT

:ubind
SET CURPTCH=7
IF EXIST MAPEDIT.INI DEL MAPEDIT.INI>>PMAPED\PATCH.LOG
COPY PMAPED\INI.ORG MAPEDIT.INI>>PMAPED\PATCH.LOG
TYPE BLOOD.CFG>>MAPEDIT.INI
TYPE PMAPED\MAPDCFG.CRK>>%CRKFILE%
GOTO PATCHIT

:defaults
%SCRMODEB%
SET CURPTCH=8
IF EXIST MAPEDIT.EXE DEL MAPEDIT.EXE>>PMAPED\PATCH.LOG
COPY PMAPED\EXE.ORG MAPEDIT.EXE>>PMAPED\PATCH.LOG
IF EXIST MAPEDIT.INI DEL MAPEDIT.INI>>PMAPED\PATCH.LOG
COPY PMAPED\INI.ORG MAPEDIT.INI>>PMAPED\PATCH.LOG
GOTO PATCHIT

:PATCHIT
CLS
ECHO [1;37m
IF .%CURPTCH% == .8 GOTO PTCH8
TYPE PMAPED\STRINGS.CRK>>%CRKFILE%
%COMSPEC% /c PMAPED\MP %CRKFILE% /C /P>>PMAPED\PATCH.LOG
TYPE PMAPED\SYSTEM\HEAD.CRK>%CRKFILE%
IF .%CURPTCH% == .0 GOTO PTCH0
IF .%CURPTCH% == .1 GOTO PTCH1
IF .%CURPTCH% == .2 GOTO PTCH2
IF .%CURPTCH% == .3 GOTO PTCH3
IF .%CURPTCH% == .4 GOTO PTCH4
IF .%CURPTCH% == .5 GOTO PTCH5
IF .%CURPTCH% == .6 GOTO PTCH6
IF .%CURPTCH% == .7 GOTO PTCH7
GOTO mscreen
:PTCH0
ECHO  BASIC PATCH HAS BEEN APPLIED!
GOTO PATCHIT_POST
:PTCH1
ECHO  NEW TYPES HAS BEEN ADDED IN LIST. THEY WILL ABLE VIA ALT+F6 IN 2D MODE.
GOTO PATCHIT_POST
:PTCH2
ECHO  PALETTE CONTROL DISABLED!
GOTO PATCHIT_POST
:PTCH3
ECHO  SPRITE SIZE CONTROL DISABLED!
GOTO PATCHIT_POST
:PTCH4
ECHO  COMMANDS UNLOCKED!
GOTO PATCHIT_POST
:PTCH5
ECHO  AUTO-ADJUST FUNCTION DISABLED...
GOTO PATCHIT_POST
:PTCH6
ECHO  MAP VERSION 7.1 IS ENABLED!
GOTO PATCHIT_POST
:PTCH7
ECHO  SETTINGS FROM BLOOD.CFG HAS BEEN COPIED TO MAPEDIT.INI.
ECHO  YOU HAVE TO EDIT IT IN NOTEPAD.
GOTO PATCHIT_POST
:PTCH8
SET CURPTCH=-1
ECHO  DEFAULT MAPEDIT.EXE AND MAPEDIT.INI WAS JUST RESTORED.
GOTO PATCHIT_POST
:PATCHIT_POST
ECHO [0m
ECHO  PRESS ANY KEY TO RETURN...
pause>nul
GOTO mscreen

:INIT_WARNING
IF NOT EXIST MAPEDIT.EXE GOTO INIT
IF NOT EXIST MAPEDIT.INI GOTO INIT
ECHO [1;31m
ECHO  PMAPEDIT BETA%VER%.
ECHO  IT LOOKS LIKE YOU USING CURRENT VERSION OF PMAPEDIT FOR THE FIRST TIME.
ECHO.
ECHO  [1;37mIF YOU ALREADY PATCHED YOUR MAPEDIT.EXE WITH PREVIOUS VERSIONS OR WITH
ECHO  ANY OTHER 3-RD SIDE PATCHES, YOU MUST RESET IT BACK TO ORIGINAL AND
ECHO  RE-APPLY PATCHES AGAIN WITH CURRENT VERSION.
ECHO.
ECHO  TO RESET MAPEDIT.EXE AND MAPEDIT.INI FILES, PRESS [1;32m[R][1;37m KEY WHILE IN
ECHO  MAIN SCREEN.
ECHO.
ECHO  PRESS ANY KEY TO CONTINUE...
IF EXIST PMAPED\SYSTEM\*.CHK DEL PMAPED\SYSTEM\*.CHK>nul
pause>nul
GOTO INIT

:exit
%SCRMODEB%
CLS
SET tcontinue=
SET CURSCR=
SET VER=
SET CURPTCH=
SET SCRMODEA=
SET SCRMODEB=
SET CRKFILE=
ECHO  [1;37m
ECHO  EXITING PROGRAM...[0m